// Plugin4W8k.cpp : Defines the entry point for the DLL application.
//

#include "stdafx.h"

#include <string.h>
#include <stdio.h>
#include <time.h>
#include "WinCon.h"
#include "RAdmPlugIn.h"

extern "C"
{

    __declspec(dllexport) void Initialize(long* major,long* minor);
	__declspec(dllexport) bool ProcessMsg(PLUGIN_MESSAGE* msg);
	__declspec(dllexport) void UnloadPlugIn();

};

int wincon8k_get_autoexec(PLUGIN_MESSAGE* msg);
int wincon8k_get_sysinfo(PLUGIN_MESSAGE* msg);
int wincon8k_set_autoexec(PLUGIN_MESSAGE* msg,char* Buf,long nBufLen);

BOOL APIENTRY DllMain( HANDLE hModule, 
                       DWORD  ul_reason_for_call, 
                       LPVOID lpReserved
					 )
{
    return TRUE;
}

void Initialize(long* major,long* minor)
{
    if(major != NULL && minor != NULL)
	{
        *major = 1;
		*minor = 0;
	}
}

bool ProcessMsg(PLUGIN_MESSAGE* msg)
{
	DWORD  ByteReads = 0;
    HANDLE hFile = (HANDLE)msg->StgHandle;
	long nBufSize = GetFileSize(hFile,0);
	if(nBufSize == 0)
		return false;
	char* pszCmd = new char [nBufSize + 1];
	memset(pszCmd,0,nBufSize + 1);
	bool nResult = false;
	if(ReadFile(hFile,pszCmd,nBufSize,&ByteReads,NULL))
	{
        char* pContent = strstr(pszCmd,"\r\n");
		if(pContent != NULL)
		{
			*pContent = '\0';
			pContent += 2;
		}
		if(strcmp(pszCmd,"get autoexec.cfg") == 0)
		    wincon8k_get_autoexec(msg);
		else if(strcmp(pszCmd,"get sysinfo") == 0)
		    wincon8k_get_sysinfo(msg);
		else if(strcmp(pszCmd,"set autoexec.cfg") == 0 && 
			pContent != NULL && 
			strlen(pContent) != 0)
		{
			wincon8k_set_autoexec(msg,pContent,strlen(pContent));
		}
		

		nResult = true;
	}
	else
		nResult = false;
	
	delete [] pszCmd;

	return nResult;
}

void UnloadPlugIn()
{
     
}

int wincon8k_get_autoexec(PLUGIN_MESSAGE* msg)
{
   char    szBuf[4096] = {0};
   char    szAnsiFileName[256] = {0};
    
   TCHAR   szFileName[256]={0};
	
   char*   pAnsiAppIDs[10] = { "Launch80",
 	                           "Launch81",
						       "Launch82",
						       "Launch83",
						       "Launch84",
						       "Launch85",
						       "Launch86",
						       "Launch87",
						       "Launch88",
							   "Launch89" };
	
	LPCTSTR pAppIDs[10] = { TEXT("Launch80"),
		                    TEXT("Launch81"),
						    TEXT("Launch82"),
						    TEXT("Launch83"),
						    TEXT("Launch84"),
						    TEXT("Launch85"),
						    TEXT("Launch86"),
						    TEXT("Launch87"),
						    TEXT("Launch88"),
						    TEXT("Launch89") };
	DWORD dwSize, dwType;
	HKEY   hKey;
	if(RegOpenKeyEx(HKEY_LOCAL_MACHINE,
		            TEXT("Init"),
					0,
					KEY_ALL_ACCESS,
					&hKey) == ERROR_SUCCESS)
	{
		for(int idx=0; idx<10; idx++)
		{
		 	dwSize=sizeof(szFileName);
			if(RegQueryValueEx(hKey,
				               pAppIDs[idx],
							   NULL,
							   &dwType,
							   (LPBYTE)szFileName,
							   &dwSize) == ERROR_SUCCESS)
			{
#ifdef UNICODE
                WideCharToMultiByte(CP_ACP,
					                0,
									szFileName,
									-1,
									szAnsiFileName,
									256,
									NULL,NULL);
#else
                strcpy(szAnsiFileName,szFileName);
#endif
                strcat(szBuf, pAnsiAppIDs[idx]);
				strcat(szBuf,"=");
				strcat(szBuf,szAnsiFileName);
				strcat(szBuf,"\r\n");
			}
			else
			{
                strcat(szBuf, pAnsiAppIDs[idx]);
				strcat(szBuf,"=\r\n");
			}
		}
		RegCloseKey(hKey);
	}

	if(strlen(szBuf) > 0)
	    msg->WriteData(msg->ConnID,
		               szBuf,
					   strlen(szBuf),
					   NULL);

	return 0; 
}

int wincon8k_set_autoexec(PLUGIN_MESSAGE* msg,char* Buf,long nBufLen)
{
    char    szBuf[4096] = {0};
	wchar_t wsValue[256];
	wchar_t wsKey[256];

	char    szAnsiFileName[256] = {0};
    
    TCHAR   szFileName[256]={0};
	
    char*   pAnsiAppIDs[10] = { "Launch80",
 	                            "Launch81",
						        "Launch82",
						        "Launch83",
						        "Launch84",
						        "Launch85",
						        "Launch86",
						        "Launch87",
						        "Launch88",
							    "Launch89" };
	
	LPCTSTR pAppIDs[10] = { TEXT("Launch80"),
		                    TEXT("Launch81"),
						    TEXT("Launch82"),
						    TEXT("Launch83"),
						    TEXT("Launch84"),
						    TEXT("Launch85"),
						    TEXT("Launch86"),
						    TEXT("Launch87"),
						    TEXT("Launch88"),
						    TEXT("Launch89") };

	char* pContent = new char[nBufLen + 1];
	memcpy(pContent,Buf,nBufLen);
	pContent[nBufLen] = 0;

	HKEY hKey;
	DWORD dwSize;
	
	if( RegOpenKeyEx(HKEY_LOCAL_MACHINE,
		             TEXT("Init"),
					 0,
					 KEY_ALL_ACCESS,
					 &hKey) == ERROR_SUCCESS)
	{
		
		char* pToken = strtok(pContent,"\r\n");
		while(pToken != NULL)
		{
            char* pValue = strchr(pToken,'=');
			if(pValue != NULL)
			{
                *pValue = 0;
				pValue++;
                
				MultiByteToWideChar(CP_ACP,0,pToken,-1,wsKey,256);
				//if(strlen(pValue) != 0)
				//{
				    MultiByteToWideChar(CP_ACP,0,pValue,-1,wsValue,256);
                    dwSize=sizeof(wsValue);
                    RegSetValueEx(hKey,
		                          wsKey,
						          NULL,
						          REG_SZ,
						          (LPBYTE)wsValue, dwSize);
				//}
				//else
  				//    RegDeleteValue(hKey,wsKey);
			}
			pToken = strtok(NULL,"\r\n");
		}

		RegFlushKey(HKEY_LOCAL_MACHINE);

		// Ū]w᪺
        for(int idx=0; idx<10; idx++)
		{
		 	DWORD dwType;
			dwSize=sizeof(szFileName);
			if(RegQueryValueEx(hKey,
				               pAppIDs[idx],
							   NULL,
							   &dwType,
							   (LPBYTE)szFileName,
							   &dwSize) == ERROR_SUCCESS)
			{

                WideCharToMultiByte(CP_ACP,
					                0,
									szFileName,
									-1,
									szAnsiFileName,
									256,
									NULL,NULL);

                strcat(szBuf, pAnsiAppIDs[idx]);
				strcat(szBuf,"=");
				strcat(szBuf,szAnsiFileName);
				strcat(szBuf,"\r\n");
			}
			else
			{
                strcat(szBuf, pAnsiAppIDs[idx]);
				strcat(szBuf,"=\r\n");
			}
		}

	    RegCloseKey(hKey);
	}
	
	delete [] pContent;

    if(strlen(szBuf) > 0)
	    msg->WriteData(msg->ConnID,
	   	               szBuf,
					   strlen(szBuf),
					   NULL);
	
	

	return 0;
}

int wincon8k_get_sysinfo(PLUGIN_MESSAGE* msg)
{
    TCHAR uni_version[80] = {0};
	char  version[80] = {0};
	char  textBuf[160];
	char  charBuf[8];
	char  OutBuf[4096];

    DWORD dwFlashSegLen;

	memset(OutBuf,0,4096);
	    
	// Display 7 I/O modules name
	for(int i=0; i<7;i++)
	{
	   sprintf(textBuf, "SLOT%d=I-%d\r\n", i + 1,8000 + GetNameOfModule(i+ 1, charBuf));
	   strcat(OutBuf,textBuf);
	   Sleep(10);
	}  
	
	// Display system serial number, only support for above Wincon hardware version 3.0
	memset(charBuf, 0, sizeof(charBuf));
	GetSystemSerialNumber(charBuf);
	sprintf(textBuf, "SERIALNUM=%X : %X : %X : %X : %X : %X : %X : %X\r\n", 
		    (unsigned char)charBuf[0], 
			(unsigned char)charBuf[1], 
			(unsigned char)charBuf[2], 
			(unsigned char)charBuf[3], 
			(unsigned char)charBuf[4], 
			(unsigned char)charBuf[5], 
			(unsigned char)charBuf[6], 
			(unsigned char)charBuf[7]);
	strcat(OutBuf,textBuf);
	
	// Display MAC address
	memset(charBuf, 0, sizeof(charBuf));
	ReadMAC((unsigned char *)charBuf);
	sprintf(textBuf, "MACADDR=%2.2X %2.2X %2.2X %2.2X %2.2X %2.2X\r\n", 
			(unsigned char)charBuf[0], 
			(unsigned char)charBuf[1], 
			(unsigned char)charBuf[2], 
			(unsigned char)charBuf[3], 
			(unsigned char)charBuf[4], 
			(unsigned char)charBuf[5]
			);
    strcat(OutBuf,textBuf);
	
	strcpy(textBuf,"EEPROM_SIZE=16K bytes\r\n");
    strcat(OutBuf,textBuf);

			// Display Flash size and Display OS image size
	sprintf(textBuf, "OS_SIZE=%ld bytes\r\n", GetFlashSize(&dwFlashSegLen));
	strcat(OutBuf,textBuf);

	if (dwFlashSegLen == FLASH_SEG_128K)
	{
		strcpy(textBuf,"FLASH_SIZE=16M bytes\r\n");		
	}
	else if (dwFlashSegLen == FLASH_SEG_256K)
	{
		strcpy(textBuf,"FLASH_SIZE=32M bytes\r\n");
	}
	else
	{
		strcpy(textBuf,"FLASH_SIZE:Unknown\r\n");
	}
	strcat(OutBuf,textBuf);

	// Display OS version
	GetOSversion(uni_version);
#ifdef UNICODE
    WideCharToMultiByte(CP_ACP,
		                0,
						uni_version,
						-1,
						version,
						80,
						NULL,NULL);
#else
    strcpy(version,uni_version);
#endif
	sprintf(textBuf,"OS_VERSION=%s\r\n",version);
	strcat(OutBuf,textBuf);
	
	// Display Wincon SDK version
	GetSDKversion(uni_version);
#ifdef UNICODE
    WideCharToMultiByte(CP_ACP,
		                0,
						uni_version,
						-1,
						version,
						80,
						NULL,NULL);
#else
    strcpy(version,uni_version);
#endif
    sprintf(textBuf,"SDK_VERSION=%s\r\n",version);
	strcat(OutBuf,textBuf);
	
	msg->WriteData(msg->ConnID,
		           OutBuf,
				   strlen(OutBuf),
				   NULL);
	return 0;
}